package test;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Label;
import org.objectweb.asm.Type;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.commons.EmptyVisitor;

import java.net.URL;
import java.io.IOException;
import java.util.Arrays;

public class App {
    public static void main(String[] args) throws Exception {
        dump(App.class);
    }

    public void foobar(int x, String y, Object[] fin) {}

    public static void dump(Class c) throws IOException {
        String classFileName = c.getName().replace('.', '/') + ".class";
        URL classFile = c.getClassLoader().getResource(classFileName);
        ClassReader cr = new ClassReader(classFile.openStream());
        cr.accept(new EmptyVisitor() {
            @Override
            public MethodVisitor visitMethod(int access, final String name, String desc, String signature, String[] exceptions) {
                final boolean isStatic = (access&Opcodes.ACC_STATIC)!=0;
                Type[] types = Type.getArgumentTypes(desc);
                final String[] names = new String[types.length];
                return new EmptyVisitor() {
                    @Override
                    public void visitLocalVariable(String name, String desc, String signature, Label start, Label end, int index) {
                        if(!isStatic)    index--;
                        if(0<=index && index<names.length)
                            names[index] = name;
                    }

                    @Override
                    public void visitEnd() {
                        System.out.println(name+" : "+ Arrays.asList(names));
                    }
                };
            }
        },0);
    }
}
